--[[
You can change values presented here to affect the gameplay.
Please use only sane values. System does will accept alsmost
anything you supply.
]]

local conf = {}

conf.caption = "Plain Pong Game"
-- if you change resolution you are encouraged to create
-- appropriate bitmap
conf.screen_width = 320
conf.screen_height = 240
conf.screen_bpp = 16

-- size of the paddle
-- small normal or big
-- actually anything that is not small or big is normal
--conf.paddle1 = "small"
--conf.paddle1 = "big"
conf.paddle1 = "normal"
conf.paddle2 = "normal"

-- should computer play with the paddle?
--conf.computer_player2 = false
conf.computer_player1 = true
conf.computer_player2 = false
--conf.computer_player2 = true

-- frames per second
conf.fsp = 30
-- do not use value less than 1 or ball will move more slowly over the time
conf.acceleration = 1.003
-- this should be relative to fsp
conf.paddle_velocity = 180 / conf.fsp
conf.ball_velocity = conf.paddle_velocity * 1.25

-- these were useful when I created bitmaps
-- now you can delete them from this file
conf.menu_image = "data/menu.bmp"
conf.end1_image = "data/end1.bmp"
conf.end2_image = "data/end2.bmp"

conf.ball_image = "data/ball.bmp"

-- if you realy want you can create new file with really big paddle
-- and point one of these tree variables to it. Game will use it!
conf.paddle_big_image = "data/paddle_big.bmp"
conf.paddle_medium_image = "data/paddle_medium.bmp"
conf.paddle_small_image = "data/paddle_small.bmp"

return conf
