require("luarocks.require")
require('alien')
require('alien.struct')
dofile("class.lua") -- http://lua-users.org/wiki/YetAnotherClassImplementation
dofile("sdl.lua")

dofile("helper_functions.lua")

dofile("game_engine.lua")
dofile("game_mode.lua")
dofile("menu_mode.lua") -- this is where game begin

math.randomseed(os.time())
game = game_engine()
game:start()

menu = menu_mode()

game:push_mode(menu)

local frame_duration = 1000/game.conf.fsp
local frame_next = SDL.SDL_GetTicks()

-- local count, nc = 0, 100
-- local start = SDL.SDL_GetTicks()

while not game.quit do
   game:handle_events()
   game:update()
   game:render()

   -- regulate the framerate to desired value
   frame_next = frame_next + frame_duration
   local ticks = SDL.SDL_GetTicks()
   if ticks < frame_next then
      local diff = frame_next - ticks
      SDL.SDL_Delay(diff)
   end

   -- calcualte and print actual framerate
--    count = count + 1
--    if (count % nc == 0) then
--       local stop = ticks
--       local fsp = nc * 1000 / (stop-start)
--       print("fsp:", fsp)
--       start = stop
--       count = 0
--    end

end
game:stop()
print('i am done')
