play_objects = newclass("play_objects")

function play_objects:init(x, y, direction, velocity, picture)
   self.x = x
   self.y = y
   self.w, self.h = 0, 0
   if picture then
      _, _, self.w, self.h = alien.struct.unpack("iLii", picture, 16)
   end
   self.direction = direction
   self.velocity = velocity
   self.picture = picture
   -- this is SDL_Rect needed for blittin
   -- allocated here because I do not want to alocate it at every frame
   self.rect = alien.buffer(8)
end

function play_objects:update(game)
   self.x = self.x + (math.cos(self.direction) * self.velocity)
   self.y = self.y + (math.sin(self.direction) * self.velocity)
end

function play_objects:render(game)
   if not self.picture then return end
   self.rect:set(1, self.x, "short")
   self.rect:set(3, self.y, "short")
--    self.rect:set(5, self.w, "short")
--    self.rect:set(7, self.h, "short")
   SDL_BlitSurface(self.picture, nil, game.screen, self.rect)
end
