require "alien"
SDL=alien.load('SDL')

local p,i,s,v="pointer","int","string", "void"
local b = "byte"
-- prepare ffi interface
SDL.SDL_Init:types(i,i)
SDL.SDL_WM_SetCaption:types(v, s, s)
SDL.SDL_SetVideoMode:types(p, i, i, i, i)
--SDL.SDL_LoadBMP:types(p,s)
SDL.SDL_LoadBMP_RW:types(p,s)
SDL.SDL_RWFromFile:types(p,s, s)
SDL.SDL_DisplayFormat:types(p,p)
SDL.SDL_FreeSurface:types(v,p)
SDL.SDL_PollEvent:types(i,p)
--SDL.SDL_BlitSurface:types(i,p,p,p,pe -- macro
SDL.SDL_UpperBlit:types(i,p,p,p,p)
SDL.SDL_UpdateRect:types(v, p, i, i, i, i)
SDL.SDL_Flip:types(i, p)
SDL.SDL_Delay:types(v, i)
SDL.SDL_FillRect:types(i, p, p, i)
SDL.SDL_MapRGB:types(i, p, b, b, b)
SDL.SDL_Quit:types(v)
SDL.SDL_GetTicks:types(i)
SDL.SDL_WM_ToggleFullScreen:types(i, p)
SDL.SDL_ShowCursor:types(i, i)

-- wrapper functions
function SDL_LoadBMP(file)
  return SDL.SDL_LoadBMP_RW(SDL.SDL_RWFromFile(file, "rb"))
end

function SDL_BlitSurface(src, srcrect, dst, dstrect)
  return SDL.SDL_UpperBlit(src, srcrect, dst, dstrect)
end

SDL_INIT_VIDEO=0x20
SDL_INIT_EVERYTHING=0xFFFF
SDL_SWSURFACE = 0x0

SDL_ENABLE = 1
SDL_DISABLE = 0
SDL_QUERY = -1

-- From /usr/include/SDL/SDL_events.h
-- /* General keyboard/mouse state definitions */
SDL_RELEASED =	0
SDL_PRESSED = 	1
SDL_KEYDOWN =	2
SDL_KEYUP = 	3
SDL_MOUSEMOTION = 4 --			/* Mouse moved */
SDL_MOUSEBUTTONDOWN = 5	--	/* Mouse button pressed */
SDL_MOUSEBUTTONUP = 6	--	/* Mouse button released */
SDL_QUIT = 	12
SDL_SYSWMEVENT = 13 --			/* System specific event */

SDL_VIDEORESIZE = 16 --			/* User resized video mode */
SDL_VIDEOEXPOSE = 17 --			/* Screen needs to be redrawn */
--       /* Events SDL_USEREVENT through SDL_NUMEVENTS-1 are for your use */
SDL_USEREVENT = 24
--       /* This last event is only for bounding internal arrays
--	  It is the number of bits in the event mask datatype -- Uint32
--        */
SDL_NUMEVENTS = 32

-- From /usr/include/SDL/SDL_keysym.h
SDLK_BACKSPACE		= 8
SDLK_TAB		= 9
SDLK_CLEAR		= 12
SDLK_RETURN		= 13
SDLK_PAUSE		= 19
SDLK_ESCAPE		= 27
SDLK_SPACE		= 32
SDLK_EXCLAIM		= 33
SDLK_QUOTEDBL		= 34
SDLK_HASH		= 35
SDLK_DOLLAR		= 36
SDLK_AMPERSAND		= 38
SDLK_QUOTE		= 39
SDLK_LEFTPAREN		= 40
SDLK_RIGHTPAREN		= 41
SDLK_ASTERISK		= 42
SDLK_PLUS		= 43
SDLK_COMMA		= 44
SDLK_MINUS		= 45
SDLK_PERIOD		= 46
SDLK_SLASH		= 47
SDLK_0			= 48
SDLK_1			= 49
SDLK_2			= 50
SDLK_3			= 51
SDLK_4			= 52
SDLK_5			= 53
SDLK_6			= 54
SDLK_7			= 55
SDLK_8			= 56
SDLK_9			= 57
SDLK_COLON		= 58
SDLK_SEMICOLON		= 59
SDLK_LESS		= 60
SDLK_EQUALS		= 61
SDLK_GREATER		= 62
SDLK_QUESTION		= 63
SDLK_AT			= 64
-- 	/* 
-- 	   Skip uppercase letters
-- 	 */
SDLK_LEFTBRACKET	= 91
SDLK_BACKSLASH		= 92
SDLK_RIGHTBRACKET	= 93
SDLK_CARET		= 94
SDLK_UNDERSCORE		= 95
SDLK_BACKQUOTE		= 96
SDLK_a			= 97
SDLK_b			= 98
SDLK_c			= 99
SDLK_d			= 100
SDLK_e			= 101
SDLK_f			= 102
SDLK_g			= 103
SDLK_h			= 104
SDLK_i			= 105
SDLK_j			= 106
SDLK_k			= 107
SDLK_l			= 108
SDLK_m			= 109
SDLK_n			= 110
SDLK_o			= 111
SDLK_p			= 112
SDLK_q			= 113
SDLK_r			= 114
SDLK_s			= 115
SDLK_t			= 116
SDLK_u			= 117
SDLK_v			= 118
SDLK_w			= 119
SDLK_x			= 120
SDLK_y			= 121
SDLK_z			= 122
SDLK_DELETE		= 127
--	/* End of ASCII mapped keysyms */
--	/* Numeric keypad */
SDLK_KP0		= 256
SDLK_KP1		= 257
SDLK_KP2		= 258
SDLK_KP3		= 259
SDLK_KP4		= 260
SDLK_KP5		= 261
SDLK_KP6		= 262
SDLK_KP7		= 263
SDLK_KP8		= 264
SDLK_KP9		= 265
SDLK_KP_PERIOD		= 266
SDLK_KP_DIVIDE		= 267
SDLK_KP_MULTIPLY	= 268
SDLK_KP_MINUS		= 269
SDLK_KP_PLUS		= 270
SDLK_KP_ENTER		= 271
SDLK_KP_EQUALS		= 272

--	/* Arrows + Home/End pad */
SDLK_UP			= 273
SDLK_DOWN		= 274
SDLK_RIGHT		= 275
SDLK_LEFT		= 276
SDLK_INSERT		= 277
SDLK_HOME		= 278
SDLK_END		= 279
SDLK_PAGEUP		= 280
SDLK_PAGEDOWN		= 281

--	/* Function keys */
SDLK_F1			= 282
SDLK_F2			= 283
SDLK_F3			= 284
SDLK_F4			= 285
SDLK_F5			= 286
SDLK_F6			= 287
SDLK_F7			= 288
SDLK_F8			= 289
SDLK_F9			= 290
SDLK_F10		= 291
SDLK_F11		= 292
SDLK_F12		= 293
SDLK_F13		= 294
SDLK_F14		= 295
SDLK_F15		= 296

--     /* Key state modifier keys */
SDLK_NUMLOCK		= 300
SDLK_CAPSLOCK		= 301
SDLK_SCROLLOCK		= 302
SDLK_RSHIFT		= 303
SDLK_LSHIFT		= 304
SDLK_RCTRL		= 305
SDLK_LCTRL		= 306
SDLK_RALT		= 307
SDLK_LALT		= 308
SDLK_RMETA		= 309
SDLK_LMETA		= 310
SDLK_LSUPER		= 311	--	/* Left "Windows" key */
SDLK_RSUPER		= 312	--	/* Right "Windows" key */
SDLK_MODE		= 313	--	/* "Alt Gr" key */
SDLK_COMPOSE		= 314	--	/* Multi-key compose key */

--	/* Miscellaneous function keys */
SDLK_HELP		= 315
SDLK_PRINT		= 316
SDLK_SYSREQ		= 317
SDLK_BREAK		= 318
SDLK_MENU		= 319
SDLK_POWER		= 320	--	/* Power Macintosh power key */
SDLK_EURO		= 321	--	/* Some european keyboards */
SDLK_UNDO		= 322	--	/* Atari keyboard has Undo */
