win_mode = newclass("win_mode", game_mode)

function win_mode:start(game)
   self.winner = game.world.winner
   self.need_render = true
end

function win_mode:stop(game)
end

function win_mode:pause(game)
end

function win_mode:resume(game)
   self.need_render = true
end

function win_mode:handle_events(game, event)
   local etype=event[1]
   if etype==SDL_QUIT then
      -- close button clicked
      game.quit=true
   end
   if etype==SDL_VIDEOEXPOSE then
      self.need_render=true
   end
   if etype==SDL_VIDEORESIZE then
      self.need_render=true
   end
   if etype==SDL_KEYUP then
      -- handle the keyboard
      sym=event[9]
--      if sym==SDLK_q or sym==SDLK_ESCAPE then
      if sym==SDLK_ESCAPE then
         self:pop_mode(game)
      elseif sym==SDLK_SPACE then
         self:pop_mode(game)
      end
   end
end

function win_mode:update(game)
end

function win_mode:render(game)
   if not self.need_render then return end
   if (self.winner == 1) then
      SDL_BlitSurface(game.pics.end1, nil, game.screen, nil)
   else
      SDL_BlitSurface(game.pics.end2, nil, game.screen, nil)
   end
   game.world.ball:render(game)
   game.world.paddle1:render(game)
   game.world.paddle2:render(game)

   SDL.SDL_UpdateRect(game.screen, 0,0,0,0)
   self.need_render = false
end
